<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="favicon.png">
  <title>ToolDef release notes | ToolDef documentation</title>
  <link rel="stylesheet" href="assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href=".">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="introduction.html">Introduction</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="language-reference/syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-cur-page toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="documentation.html">ToolDef documentation</a> &gt; <span class="breadcrumb">ToolDef release notes</span>
   </div>
   <h2 id="tooldef-release-notes"><a class="anchor" href="#"></a>ToolDef release notes</h2>
   <div class="sectionbody">
    <div class="paragraph">
     <p>The release notes for the versions of ToolDef and the associated tools, as part of the Eclipse ESCET project, are listed below in reverse chronological order.</p>
    </div>
    <div class="paragraph">
     <p>See also the Eclipse ESCET <a href="https://eclipse.dev/escet/v5.0/release-notes.html">toolkit release notes</a> covering those aspects that are common to the various Eclipse ESCET tools.</p>
    </div>
    <div class="sect2">
     <h3 id="version-5-0-2024-10-03"><a class="anchor" href="#version-5-0-2024-10-03"></a>Version 5.0 (2024-10-03)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef built-in tools that work on user-provided paths no longer crash when an invalid path is provided, but instead give a proper error message (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/924">#924</a>).</p></li>
       <li><p>The ToolDef interpreter no longer crashes on user-specified Java method invocations that result in an exception (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/925">#925</a>).</p></li>
       <li><p>The ToolDef documentation has a small fix (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/943">#943</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-4-0-2024-06-30"><a class="anchor" href="#version-4-0-2024-06-30"></a>Version 4.0 (2024-06-30)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The 'ToolDef tool manual' page in the ToolDef documentation has been renamed to 'ToolDef interpreter', to avoid giving the impression that the page explains ToolDef’s built-in tools (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/825">#825</a>).</p></li>
       <li><p>The ToolDef documentation has some small improvements (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/825">#825</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-3-0-2024-03-31"><a class="anchor" href="#version-3-0-2024-03-31"></a>Version 3.0 (2024-03-31)</h3>
     <div class="paragraph">
      <p>New features:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef interpreter now supports reading <code>.tooldefx</code> files, ToolDef files in an XML format (issues <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/701">#701</a> and <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/731">#731</a>).</p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef documentation breadcrumbs are now consistent with the table of contents (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/38">#38</a>).</p></li>
       <li><p>The ToolDef documentation table of contents now has proper links for items that link to sections on pages rather than to entire pages (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/38">#38</a>).</p></li>
       <li><p>The ToolDef website has an improved link color (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/38">#38</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-2-0-2023-12-22"><a class="anchor" href="#version-2-0-2023-12-22"></a>Version 2.0 (2023-12-22)</h3>
     <div class="paragraph">
      <p>This release contains no specific changes for ToolDef.</p>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-1-0-2023-09-30"><a class="anchor" href="#version-1-0-2023-09-30"></a>Version 1.0 (2023-09-30)</h3>
     <div class="paragraph">
      <p>This release contains no specific changes for ToolDef.</p>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-10-2023-06-30"><a class="anchor" href="#version-0-10-2023-06-30"></a>Version 0.10 (2023-06-30)</h3>
     <div class="paragraph">
      <p>New features:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef interpreter has a new <em>Tool invocation</em> option to invoke a specific tool with chosen arguments, rather than executing the entire script (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/578">#578</a>).</p></li>
       <li><p>The <code>writefile</code> built-in tool has a new optional <code>newline</code> parameter, allowing to configure new line handling. The default is still to use the new lines of the current platform. See the documentation for further details (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/571">#571</a>).</p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The <code>readlines</code> and <code>writefile</code> built-in tools have been made more robust with respect to closing file streams in case of I/O errors (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/571">#571</a>).</p></li>
       <li><p>The <code>readlines</code> built-in tool now uses the UTF-8 encoding when reading files, rather than the platform’s default encoding (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/571">#571</a>).</p></li>
       <li><p>The <code>readlines</code> and <code>writefile</code> built-in tools now have improved documentation (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/571">#571</a>).</p></li>
       <li><p>The ToolDef interpreter’s help text now properly explains the tool’s exit codes (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/573">#573</a>).</p></li>
       <li><p>The ToolDef interpreter documentation has been slightly improved (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/578">#578</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-9-2023-03-31"><a class="anchor" href="#version-0-9-2023-03-31"></a>Version 0.9 (2023-03-31)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef documentation has some improvements related to 'file separator' terminology (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/450">#450</a>).</p></li>
       <li><p>The ToolDef documentation for the <code>chfileext</code> tool has some formatting fixes (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/536">#536</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-8-2022-12-21"><a class="anchor" href="#version-0-8-2022-12-21"></a>Version 0.8 (2022-12-21)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The <code>filenewer</code> tool now only checks for modification time differences that are at least one millisecond (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/259">#259</a>).</p></li>
       <li><p>Small documentation improvement for the <code>filenewer</code> tool documentation (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/456">#456</a>).</p></li>
       <li><p>Normally, <code>.tooldef</code> files are opened with the ToolDef text editor. Large files are now however opened with the default non-ToolDef text editor to avoid performance issues. You can open a file in an editor of your choosing by right clicking it and selecting <b class="menuref">Open With</b> and then selecting the editor of your choosing, or choosing <b class="menuref">Other…​</b> to open a dialog to choose from a larger selection of editors (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/199">#199</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-7-2022-09-30"><a class="anchor" href="#version-0-7-2022-09-30"></a>Version 0.7 (2022-09-30)</h3>
     <div class="paragraph">
      <p>New features:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef text editor now has theming support, and comes with a dark theme in addition to the existing light theme. The text editor now automatically uses its dark theme when the Eclipse built-in dark theme is used, and uses a light theme otherwise. The text editor theming behavior can be configured via the Eclipse Preferences dialog (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/347">#347</a>).</p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The ToolDef text editor light theme’s default color has changed from a near-black slightly-brown color to pure black (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/347">#347</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-6-2022-07-07"><a class="anchor" href="#version-0-6-2022-07-07"></a>Version 0.6 (2022-07-07)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>Links in the documentation to non-ToolDef ESCET documentation webpages now use version-specific URLs (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/386">#386</a>).</p></li>
       <li><p>The issue numbers in the release notes now link to the corresponding GitLab issue (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/396">#396</a>).</p></li>
       <li><p>Small website style improvements (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/367">#367</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-5-2022-03-29"><a class="anchor" href="#version-0-5-2022-03-29"></a>Version 0.5 (2022-03-29)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The release notes for each version now contain the release date, with the exception of milestone releases and release candidates (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/314">#314</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-4-2021-12-17"><a class="anchor" href="#version-0-4-2021-12-17"></a>Version 0.4 (2021-12-17)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>Introduced a brand new website (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/35">#35</a>).</p></li>
       <li><p>Many website URLs have changed due to various website structure changes (issues <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/35">#35</a> and <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/73">#73</a>).</p></li>
       <li><p>Various documentation/website textual improvements, style improvements and other changes (issues <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/35">#35</a> and <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/54">54</a>).</p></li>
       <li><p>Multiple small error message improvements (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/248">#248</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-3-2021-10-01"><a class="anchor" href="#version-0-3-2021-10-01"></a>Version 0.3 (2021-10-01)</h3>
     <div class="paragraph">
      <p>Improvements and fixes:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>The website and Eclipse help now use multi-page HTML rather than a single HTML file, although the website still contains a link to the single-page HTML that allows easily searching the full documentation (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/36">#36</a>).</p></li>
       <li><p>Enabled section anchors for documentation on the website, and disabled section anchors for Eclipse help (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/36">#36</a>).</p></li>
       <li><p>Several small documentation fixes and improvements (issue <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues/166">#166</a>).</p></li>
      </ul>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-2-2021-07-07"><a class="anchor" href="#version-0-2-2021-07-07"></a>Version 0.2 (2021-07-07)</h3>
     <div class="paragraph">
      <p>This release contains no specific changes for ToolDef.</p>
     </div>
    </div>
    <div class="sect2">
     <h3 id="version-0-1-2021-04-02"><a class="anchor" href="#version-0-1-2021-04-02"></a>Version 0.1 (2021-04-02)</h3>
     <div class="paragraph">
      <p>The first release of ToolDef as part of the Eclipse ESCET project. This release is based on the initial contribution by the Eindhoven University of Technology (TU/e).</p>
     </div>
     <div class="paragraph">
      <p>Most notable changes compared to the last TU/e release:</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>We no longer use separate language and tool versions. The <code>.tooldef2</code> file extension has been changed to <code>.tooldef</code> as part of this change.</p></li>
      </ul>
     </div>
    </div>
   </div>
  </div>
  <script src="assets/highlight.min.js"></script>
  <script src="assets/languages/asciidoc.min.js"></script>
  <script src="assets/languages/bash.min.js"></script>
  <script src="assets/languages/bnf.min.js"></script>
  <script src="assets/languages/c.min.js"></script>
  <script src="assets/languages/chi.min.js"></script>
  <script src="assets/languages/cif.min.js"></script>
  <script src="assets/languages/console.min.js"></script>
  <script src="assets/languages/css.min.js"></script>
  <script src="assets/languages/dsm.min.js"></script>
  <script src="assets/languages/java.min.js"></script>
  <script src="assets/languages/javascript.min.js"></script>
  <script src="assets/languages/markdown.min.js"></script>
  <script src="assets/languages/mcrl2.min.js"></script>
  <script src="assets/languages/none.min.js"></script>
  <script src="assets/languages/plcst.min.js"></script>
  <script src="assets/languages/properties.min.js"></script>
  <script src="assets/languages/raildiagram.min.js"></script>
  <script src="assets/languages/setext.min.js"></script>
  <script src="assets/languages/shell.min.js"></script>
  <script src="assets/languages/tooldef.min.js"></script>
  <script src="assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v5.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>